###########################################################################################################
# Script by Frank Zchling																				  
# www.frankysweb.de									
# frank@frankysweb.de
# 
# Script fr die Basis Konfiguration von Exchange 2010
#
# v1.20
#
###########################################################################################################
#
#Bildschirminhalt zu besseren Lesbarkeit lschen

clear-host

#Benutzer nach bentigten Daten fragen

write-host
write-host "Wie soll die erste Postfach Datenbank heien?" -ForegroundColor yellow
write-host " Beispiel: MBDB01"
write-host
$MDBname = read-host "Name"
write-host 
write-host "Wo soll die Datenbank $MDBname gespeichert werden?" -ForegroundColor yellow
write-host " Beispiel: D:\MBDB01"
write-host
$MDBpath = read-host "Pfad"
write-host

# Abfrage ob ffentliche Ordner Datenbank existiert

function QPFDBJ
 {
  $global:QPFDB = 1
  write-host
  write-host "Wie soll die Datenbank fr ffentliche Ordner heien?" -ForegroundColor yellow
  write-host " Beispiel: PFDB01"
  write-host
  $global:PFDBname = read-host "Name"
  write-host
  write-host "Wo soll die Datenbank $PFDBname fr ffentliche Ordner gespeichert werden?" -ForegroundColor yellow
  write-host " D:\PFDB01"
  write-host
  $global:PFDBpath = read-host "Pfad"
 }
function QPFDBN
 {
 }
write-host "Gibt es eine Datenbank fr ffentliche Ordner?" -ForegroundColor yellow
write-host 
$choice = Read-Host "Geben Sie 'J' fr Ja oder 'N' fr Nein ein"
& "QPFDB$choice"

# Abfrage akzeptierte Domain

write-host
write-host "Wie lautet die Maildomain?" -ForegroundColor yellow
write-host " Wenn Ihre Mailadressen zum Beispiel info@frankysweb.de lauten, dann geben Sie 'frankysweb.de' ein."
write-host
$global:accdomain = read-host "Domain"

# Abfrage Sendeconnector

function QSCS
 {
 $global:QSC = 0
 write-host
 write-host "Bitte geben Sie die IP-Adresse oder den FQDN des Smarthosts an" 
 write-host
 $global:ship = read-host "IP oder FQDN"
 write-host
 write-host "Bitte geben Sie den Port fr den Smarthost an (Normalerweise 25,in einigen Fllen 587)" 
 write-host
 $global:shport = read-host "Port"
 write-host
 write-host "Bitte geben Sie Benutzer und Passwort fr den Smarthost ein"
 write-host
 $sbenutzer = read-host "Benutzer"
 $spass = read-host "Passwort" -assecurestring
  $global:creds = new-object -typename System.Management.Automation.PSCredential -argumentlist $sbenutzer, $spass
 }
function QSCD
 {
  $global:QSC = 1
 }
write-host
write-host "Wie werden E-Mails versendet? Via Smarthost oder via DNS?" -ForegroundColor yellow
write-host 
 $choice = Read-Host " Geben Sie 'S' fr Smarthost oder 'D' fr DNS ein"
 & "QSC$choice"

# Abfrage externe URL

write-host
write-host "Wie lautet die externe Hostname?" -ForegroundColor yellow
write-host " Welcher Hostname wird fr OWA, Outlook Anywhere, ECP, etc. verwendet?"
write-host " Wenn sie ber 'https://owa.frankysweb.de/owa' auf OWA zugreifen, geben Sie 'owa.frankysweb.de' ein"
write-host
 $global:exhostname = read-host "URL"
  $externalurl = "https://$exhostname"
#Abfage ob eine Zertifikatsanforderung erstellt werden soll

function QCertJ
 {
  $global:QCert = 1
  write-host
  write-host "Wie lautet der Name des Unternehmens?"
  $global:ORG = read-host "Name"
  write-host "In welchem Bundesland befindet sich das Unternehmen?"
  $global:CAN = read-host "Name"
  write-host "In welchem Ort befindet sich das Unternehmen?"
  $global:ORT = read-host "Name"
  write-host 
 }
function QCertN
 {
 }
write-host
write-host "Soll eine Zertifikatsanforderung erstellt werden?" -ForegroundColor yellow
write-host " Die zertifikatsanforderung wird auf dem Desktop als $computer.req gespeichert"
write-host 
$choice = Read-Host "Geben Sie 'J' fr Ja oder 'N' fr Nein ein"
& "QCert$choice"

###########################################################################################################
#####                                Exchange konfigurieren                                           #####
###########################################################################################################

# Hostnamen des lokalen Exchange Servers abfragen

$global:computer = gc env:computername

#Name und Pfad der Postfachdatenbank ndern

Get-MailboxDatabase | Set-MailboxDatabase -Name "$MDBname" 
move-DatabasePath -Identity "$MDBname" -EdbFilePath "$MDBpath\$MDBname.edb" -LogFolderPath "$MDBpath"

#Name und Pfad der Public Folder Database ndern

If ($QPFDB -gt 0)
 {
  Get-PublicFolderDatabase | Set-PublicFolderDatabase -Name "$PFDBname"
  move-DatabasePath -Identity "$PFDBname" -EdbFilePath "$PFDBpath\$PFDBname.edb" -LogFolderPath "$PFDBpath"
 }
# Sendconnector konfigurieren

If ($QSC -gt 0)
 {
  new-SendConnector -Name 'SMTP-Out' -Usage 'Internet' -AddressSpaces 'SMTP:*;1' -IsScopedConnector $false -DNSRoutingEnabled $true -UseExternalDNSServersEnabled $false -SourceTransportServers "$computer"
 }
else
 {
  new-SendConnector -Name 'SMTP-Out' -Usage 'Internet' -AddressSpaces 'SMTP:*;1' -IsScopedConnector $false -DNSRoutingEnabled $false -SmartHosts "[$ship]" -Port "$shport" -SmartHostAuthMechanism 'BasicAuth' -UseExternalDNSServersEnabled $false -AuthenticationCredential $creds -SourceTransportServers "$computer"
 }

#Externer Zugriff fr OWA,OAB,ECP, ect. ndern

Set-OwaVirtualDirectory -ExternalUrl "$externalurl/OWA" -Identity "$computer\owa (Default Web Site)"
Set-EcpVirtualDirectory -ExternalUrl "$externalurl/ECP" -Identity "$computer\ecp (Default Web Site)"
Set-ActiveSyncVirtualDirectory -ExternalUrl "$externalurl/Microsoft-Server-ActiveSync" -Identity "$computer\Microsoft-Server-ActiveSync (Default Web Site)"
Set-OabVirtualDirectory -ExternalUrl "$externalurl/OAB" -Identity "$computer\OAB (Default Web Site)"

#Neue akzeptierte Doain hinzufgen

new-AcceptedDomain -Name "$accdomain" -DomainName "$accdomain" -DomainType "Authoritative"
 Set-AcceptedDomain -Identity "$accdomain" -MakeDefault $true

# Zertifikatsanforderung erstellen

If ($QCERT -gt 0)
 {
  $global:localdom = $env:USERDNSDOMAIN
  $subname = "C=DE,S=$CAN,L=$ORT,O=$ORG,OU=IT,CN=$computer.$localdom"
  $domname1 = "$exhostname"
  $domname2 = "autodiscover.$accdomain"
  $domname3 = "autodiscover.$localdom"
  $newcertreq = New-ExchangeCertificate -GenerateRequest -SubjectName "$subname" -DomainName $domname1,$domname2,$domname3 -IncludeServerNetBIOSName -IncludeServerFQDN -BinaryEncoded -PrivateKeyExportable $true 
   Set-Content -path "$home\desktop\$computer.req" -Value $newcertreq.FileData -Encoding Byte
 }
 
#Default Empfangsconnector: Anonymes Empfangen erlauben

Set-ReceiveConnector -PermissionGroups "AnonymousUsers, ExchangeUsers, ExchangeServers, ExchangeLegacyServers" -Identity "$computer\Default $computer"